    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one
    003 * or more contributor license agreements.  See the NOTICE file
    004 * distributed with this work for additional information
    005 * regarding copyright ownership.  The ASF licenses this file
    006 * to you under the Apache License, Version 2.0 (the
    007 * "License"); you may not use this file except in compliance
    008 * with the License.  You may obtain a copy of the License at
    009 *
    010 * http://www.apache.org/licenses/LICENSE-2.0
    011 *
    012 * Unless required by applicable law or agreed to in writing,
    013 * software distributed under the License is distributed on an
    014 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015 * KIND, either express or implied.  See the License for the
    016 * specific language governing permissions and limitations
    017 * under the License.
    018 */
    019package org.apache.commons.compress.archivers.jar;
    020
    021import java.io.IOException;
    022import java.io.OutputStream;
    023
    024import org.apache.commons.compress.archivers.ArchiveEntry;
    025import org.apache.commons.compress.archivers.zip.JarMarker;
    026import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
    027import org.apache.commons.compress.archivers.zip.ZipArchiveOutputStream;
    028
    029/**
    030 * Subclass that adds a special extra field to the very first entry
    031 * which allows the created archive to be used as an executable jar on
    032 * Solaris.
    033 *
    034 * @NotThreadSafe
    035 */
    036public class JarArchiveOutputStream extends ZipArchiveOutputStream {
    037
    038    private boolean jarMarkerAdded = false;
    039
    040    public JarArchiveOutputStream(final OutputStream out) {
    041        super(out);
    042    }
    043
    044    /**
    045     * Create and instance that wraps the output stream using the provided encoding.
    046     *
    047     * @param out the output stream to wrap
    048     * @param encoding the encoding to use. Use null for the platform default.
    049     * @since 1.10
    050     */
    051    public JarArchiveOutputStream(final OutputStream out, final String encoding) {
    052        super(out);
    053        setEncoding(encoding);
    054    }
    055
    056    // @throws ClassCastException if entry is not an instance of ZipArchiveEntry
    057    @Override
    058    public void putArchiveEntry(final ArchiveEntry ze) throws IOException {
    059        if (!jarMarkerAdded) {
    060            ((ZipArchiveEntry)ze).addAsFirstExtraField(JarMarker.getInstance());
    061            jarMarkerAdded = true;
    062        }
    063        super.putArchiveEntry(ze);
    064    }
    065}